"use strict";

const SvxWebsocket = require("./lib/src/svx_websocket").default;
const Rpc = require("./lib/src/rpc").default;

let svxWebsocket = function svxWebsocketModule (merapi) {
    return {
        dependencies: [
            "svx"
        ],

        async onAfterPluginInit(container) {
            container.register("websocket", SvxWebsocket);
            let websocket = await container.resolve("websocket");
            await websocket.start();
        },
    }
}

svxWebsocket.Rpc = Rpc;
module.exports = svxWebsocket;
