import { JsonObject } from "merapi";
import { ITransport } from "merapi-plugin-svx";
export interface ISvxWebsocket extends ITransport {
    initialize(): Promise<void>;
    name(): string;
    priority(): number;
    info(): JsonObject;
    hasTransport(type: string): boolean;
}
export declare type SvxSource = {
    eventId: string;
    serviceName: string;
    instanceId: string;
    serviceVersion: string;
    timestamp: number;
};
export interface IRpc {
    handleMessage(str: string | JsonObject): Promise<void>;
    sendMessage(payload: JsonObject): void;
    exec(command: string, args: any[]): Promise<{}>;
    createCommand(command: string, handler: Function): void;
    removeCommand(command: string): void;
}
