import { Component, IConfigReader, ILogger, Json, JsonObject } from "merapi";
import { ISvxWebsocket, SvxSource, IRpc } from "./interface";
import { IService, Result } from "merapi-plugin-svx";
export default class SvxWebsocket extends Component implements ISvxWebsocket {
    private config;
    private logger;
    private service;
    private _connection;
    private _moduleName;
    private _priority;
    private _version;
    private _supportTransport;
    constructor(config: IConfigReader, logger: ILogger, service: IService);
    initialize(): Promise<void>;
    private doConnect();
    start(): Promise<void>;
    name(): string;
    priority(): number;
    info(): JsonObject;
    hasTransport(type: string): boolean;
    getConnection(): IRpc;
    publishTopic(service: string, topic: string, version: number, payload: Json, source: SvxSource): Promise<void>;
    subscribeTopic(service: string, topic: string, version: number, handler: (payload: Json, source: SvxSource) => Promise<void> | void): void;
    unsubscribeTopic(service: string, topic: string, version: number): void;
    pushQueue(service: string, queue: string, version: number, payload: Json, source: SvxSource): void;
    consumeQueue(service: string, queue: string, version: number, handler: (payload: Json, source: SvxSource) => Promise<void>): void;
    callApi(service: string, method: string, version: number, args: Json[], source: SvxSource): Promise<any>;
    createApi(service: string, method: string, version: number, handler: (args: Json[], source: JsonObject) => Promise<Json>): void;
    watchApiCall(service: string, method: string, version: number): Promise<Result>;
    watchApiResult(service: string, method: string, version: number): Promise<Result>;
    execCommand(service: string, command: string, args: Json[], source: JsonObject): Promise<any>;
    createCommand(service: string, command: string, handler: (args: Json[], source: JsonObject) => Promise<Json>): void;
    handleBroadcast(): void;
    broadcast(info: any): Promise<void>;
    discover(timeout?: number): Promise<void>;
    subscribeLog(service: string, level: string, handler: (payload: Json, source: SvxSource) => Promise<void> | void): void;
    log(service: string, component: string, method: string, level: string, message: Json): void;
}
